/*
 File: term_def_ph.cpp
 Date and Time: Fri Jan 30 18:55:26 2015 
*/
#include "term_def_ph.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_term_def_ph;// grammar's ns
// first set terminals
fsm_rules_reuse_table_type::fsm_rules_reuse_table_type(){
 no_rules_entries_ = 16;
 per_rule_s_table_[0] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[1] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[2] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[3] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[4] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[5] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[6] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[7] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[8] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[9] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[10] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[11] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[12] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[13] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[14] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[15] =  new Per_rule_s_reuse_table();
}
  Cterm_def_ph::
  Cterm_def_ph()
    :yacco2::CAbs_fsm
      ("term_def_ph.lex"
      ,"1.0"
      ,"24 mar 2004"
      ,false
      ,"Parse a terminal symbol."
      ,"Fri Jan 30 18:55:26 2015 "
      ,S1_Cterm_def_ph){
    
      term_def_ = 0;
  
  }
 
Cterm_def_ph::~Cterm_def_ph(){

  for(int x = 0;x < 16;++x){
   ///delete fsm_rules_reuse_table.per_rule_s_table_[x];
  }
} 

  bool Cterm_def_ph::failed(){
      return false;
  }
  void Cterm_def_ph::op(){
    if(term_def_ != 0){
      delete term_def_;
      term_def_ = 0;
    }
    term_def_ = new T_terminal_def;
    term_def_->set_rc(*parser__->start_token__,__FILE__,__LINE__);
  
}
int Cterm_def_ph::rhs_to_rules_mapping_[43] = {
 -1
 ,0 // subrule 1 for rule 1
 ,1 // subrule 2 for rule 2
 ,1 // subrule 3 for rule 2
 ,1 // subrule 4 for rule 2
 ,1 // subrule 5 for rule 2
 ,1 // subrule 6 for rule 2
 ,1 // subrule 7 for rule 2
 ,1 // subrule 8 for rule 2
 ,2 // subrule 9 for rule 3
 ,2 // subrule 10 for rule 3
 ,2 // subrule 11 for rule 3
 ,3 // subrule 12 for rule 4
 ,3 // subrule 13 for rule 4
 ,4 // subrule 14 for rule 5
 ,4 // subrule 15 for rule 5
 ,4 // subrule 16 for rule 5
 ,5 // subrule 17 for rule 6
 ,6 // subrule 18 for rule 7
 ,6 // subrule 19 for rule 7
 ,7 // subrule 20 for rule 8
 ,7 // subrule 21 for rule 8
 ,7 // subrule 22 for rule 8
 ,8 // subrule 23 for rule 9
 ,8 // subrule 24 for rule 9
 ,9 // subrule 25 for rule 10
 ,9 // subrule 26 for rule 10
 ,10 // subrule 27 for rule 11
 ,10 // subrule 28 for rule 11
 ,11 // subrule 29 for rule 12
 ,11 // subrule 30 for rule 12
 ,12 // subrule 31 for rule 13
 ,12 // subrule 32 for rule 13
 ,13 // subrule 33 for rule 14
 ,13 // subrule 34 for rule 14
 ,13 // subrule 35 for rule 14
 ,13 // subrule 36 for rule 14
 ,13 // subrule 37 for rule 14
 ,13 // subrule 38 for rule 14
 ,14 // subrule 39 for rule 15
 ,14 // subrule 40 for rule 15
 ,15 // subrule 41 for rule 16
 ,15 // subrule 42 for rule 16
}; 

    void Cterm_def_ph::
    add_sdc_to_directive(CAbs_lr1_sym* Dir,T_syntax_code* Sdc){
      using namespace NS_yacco2_T_enum;
      using namespace NS_yacco2_terminals;
      yacco2::INT eid = Dir->enumerated_id__;
      switch (eid){
		case T_Enum::T_T_user_declaration_: {
		  T_user_declaration* k = (T_user_declaration*)Dir;
		  k->syntax_code(Sdc);
		  break;
		}      
		case T_Enum::T_T_constructor_: {
		  T_constructor* k = (T_constructor*)Dir;
		  k->syntax_code(Sdc);
		  break;
		}      
		case T_Enum::T_T_destructor_: {
		  T_destructor* k = (T_destructor*)Dir;
		  k->syntax_code(Sdc);
		  break;
		}      
		case T_Enum::T_T_op_: {
		  T_op* k = (T_op*)Dir;
		  k->syntax_code(Sdc);
		  break;
		}      
		case T_Enum::T_T_user_implementation_: {
		  T_user_implementation* k = (T_user_implementation*)Dir;
		  k->syntax_code(Sdc);
		  break;
		}      
		default: {
          CAbs_lr1_sym* sym = new Err_improper_directive;
          sym->set_rc(*Dir,__FILE__,__LINE__);
          RSVP_FSM(sym);
          parser__->set_stop_parse(true);
   		}      
      }    
    }
  
Rterminal_def_phrase::Rterminal_def_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rterminal_def_phrase",0,Cterm_def_ph::R_Rterminal_def_phrase_,P,false,false){
}

void Rterminal_def_phrase::sr1(){
  
      Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
      RSVP(fsm->term_def_);
      // add to global symbol table
      const char* skey = fsm->term_def_->t_name()->c_str();
      T_sym_tbl_report_card report_card;
      T_in_stbl* tin = new T_in_stbl(fsm->term_def_
		,rule_info__.parser__->start_token__,rule_info__.parser__);
      STBL_T_ITEMS.push_back(tin);
      using namespace yacco2_stbl;
      add_sym_to_stbl(report_card,*skey,*tin,table_entry::defed,table_entry::terminal);
	  	if(report_card.status_ != T_sym_tbl_report_card::okay){
			report_card.err_entry_->set_rc(*rule_info__.parser__->start_token__,__FILE__,__LINE__);
			ADD_TOKEN_TO_ERROR_QUEUE(*report_card.err_entry_);
			rule_info__.parser__->set_stop_parse(true);
			return;
		}
	  tin->stbl_idx(report_card.pos_);
      fsm->term_def_ = 0;
    
}

Rid::Rid(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rid",0,Cterm_def_ph::R_Rid_,P,false,false){
}

void Rid::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_c_string* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
        const char* skey = sf->p2__->c_string()->c_str();
        fsm->term_def_->t_name(skey);
        sf->p2__->set_auto_delete(true);
        T_sym_tbl_report_card report_card;
        using namespace yacco2_stbl;
        find_sym_in_stbl(report_card,*skey);
        if(report_card.action_ == T_sym_tbl_report_card::fnd){
          CAbs_lr1_sym* sym = new Err_dup_entry_in_sym_table;
          sym->set_rc(*sf->p2__,__FILE__,__LINE__);
          RSVP(sym);
          rule_info__.parser__->set_stop_parse(true);
          return;
        }
      
}

void Rid::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
        const char* skey = sf->p2__->identifier()->c_str();
        fsm->term_def_->t_name(skey);
        sf->p2__->set_auto_delete(true);
      
}

void Rid::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_in_stbl* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
          CAbs_lr1_sym* sym = new Err_dup_entry_in_sym_table;
          sym->set_rc(*sf->p2__,__FILE__,__LINE__);
          RSVP(sym);
          rule_info__.parser__->set_stop_parse(true);
          return;
      
}

void Rid::sr4(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rid::sr5(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_lrk_sufx* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        sf->p2__->set_auto_delete(true);
        rule_info__.parser__->set_abort_parse(true);
      
}

void Rid::sr6(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_terminals_sufx* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        sf->p2__->set_auto_delete(true);
        rule_info__.parser__->set_abort_parse(true);
      
}

void Rid::sr7(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_terminals_refs* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
          sf->p2__->set_auto_delete(true);
        rule_info__.parser__->set_abort_parse(true);
      
}

Rad_ab_tags::Rad_ab_tags(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rad_ab_tags",0,Cterm_def_ph::R_Rad_ab_tags_,P,false,false){
}

Rad_ab_tag::Rad_ab_tag(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rad_ab_tag",0,Cterm_def_ph::R_Rad_ab_tag_,P,false,false){
}

void Rad_ab_tag::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_AD* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
        if(fsm->term_def_->autodelete() == true){
			CAbs_lr1_sym* sym = new Err_already_defined_AD;
			sym->set_rc(*sf->p2__,__FILE__,__LINE__);
			RSVP(sym);
			rule_info__.parser__->set_stop_parse(true);
			return;
        }
        fsm->term_def_->autodelete(true);
      
}

void Rad_ab_tag::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_AB* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
        if(fsm->term_def_->autoabort() == true){
			CAbs_lr1_sym* sym = new Err_already_defined_AB;
			sym->set_rc(*sf->p2__,__FILE__,__LINE__);
			RSVP(sym);
			rule_info__.parser__->set_stop_parse(true);
			return;
        }
        fsm->term_def_->autoabort(true);
      
}

Rsym_cweb_k::Rsym_cweb_k(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_cweb_k",0,Cterm_def_ph::R_Rsym_cweb_k_,P,false,false){
}

void Rsym_cweb_k::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_cweb_comment* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
      T_cweb_comment* k = sf->p2__;
      AST* cwebk_t_ = new AST(*k);

      AST* cweb_t_ = new AST();
      T_cweb_marker* cw = new T_cweb_marker(cweb_t_);
      AST::set_content(*cweb_t_,*cw);
        AST::join_pts(*cweb_t_,*cwebk_t_);

      cw->set_rc(*k,__FILE__,__LINE__);
      AST::set_content(*cweb_t_,*cw);
        fsm->term_def_->add_cweb_marker(cw->ast());
  
}

void Rsym_cweb_k::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
		RSVP(sf->p2__);
		rule_info__.parser__->set_stop_parse(true); 
      
}

Rsym_class_phrase::Rsym_class_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_class_phrase",0,Cterm_def_ph::R_Rsym_class_phrase_,P,false,false){
}

Rsym_class::Rsym_class(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_class",0,Cterm_def_ph::R_Rsym_class_,P,false,false){
}

void Rsym_class::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_sym_class_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rsym_class_id::Rsym_class_id(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_class_id",0,Cterm_def_ph::R_Rsym_class_id_,P,false,false){
}

void Rsym_class_id::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
        Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
        fsm->term_def_->classsym(sf->p2__->identifier()->c_str());
        sf->p2__->set_auto_delete(true);
      
}

void Rsym_class_id::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_sym_class_id_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rsym_class_id::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_sym_class_id_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rpotential_code_blk::Rpotential_code_blk(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rpotential_code_blk",0,Cterm_def_ph::R_Rpotential_code_blk_,P,false,false){
}

Ropen_par::Ropen_par(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Ropen_par",0,Cterm_def_ph::R_Ropen_par_,P,false,false){
}

void Ropen_par::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_open_parenthesis;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rclose_par::Rclose_par(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rclose_par",0,Cterm_def_ph::R_Rclose_par_,P,false,false){
}

void Rclose_par::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_close_parenthesis;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rclosing_brace::Rclosing_brace(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rclosing_brace",0,Cterm_def_ph::R_Rclosing_brace_,P,false,false){
}

void Rclosing_brace::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_close_brace;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rdirectives::Rdirectives(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rdirectives",0,Cterm_def_ph::R_Rdirectives_,P,false,false){
}

void Rdirectives::sr1(){
  struct SF{
   Rdirective* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rsyntax_code* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rlint* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(3);
  
      Rdirective* dir = sf->p1__;
      Rsyntax_code* sdc = sf->p2__;
      Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
      fsm->add_sdc_to_directive(dir->directive_,sdc->syntax_code_);
    
}

void Rdirectives::sr2(){
  struct SF{
   Rdirectives* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rdirective* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rsyntax_code* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
   Rlint* p4__;
   State* s4__;
   bool abort4__;
   Rule_s_reuse_entry* rule_s_reuse_entry4__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(4);
  
      Rdirective* dir = sf->p2__;
      Rsyntax_code* sdc = sf->p3__;
      Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
      fsm->add_sdc_to_directive(dir->directive_,sdc->syntax_code_);
    
}

Rdirective::Rdirective(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rdirective",0,Cterm_def_ph::R_Rdirective_,P,false,false){
}

void Rdirective::op(){
  sstrace_rulesss
 
    if(directive_ == 0) return;
    Cterm_def_ph* fsm = (Cterm_def_ph*)rule_info__.parser__->fsm_tbl__;
    CAbs_lr1_sym* result = 
	fsm->term_def_->add_directive_to_map(directive_,rule_info__.parser__);
    if(result == 0) return;// ok added
    directive_->set_auto_delete(true);//dup: delete when popped from stack
    RSVP(result);
    rule_info__.parser__->set_stop_parse(true);
  
}
void Rdirective::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_user_declaration* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rdirective::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_user_implementation* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rdirective::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_constructor* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rdirective::sr4(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_destructor* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rdirective::sr5(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_op* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      directive_ = sf->p2__;
    
}

void Rdirective::sr6(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
		directive_ = 0;
        sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_bad_directive;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rsyntax_code::Rsyntax_code(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsyntax_code",0,Cterm_def_ph::R_Rsyntax_code_,P,false,false){
}

void Rsyntax_code::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_syntax_code* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        syntax_code_ = sf->p2__;
      
}

void Rsyntax_code::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
		syntax_code_ = 0;
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rlint::Rlint(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rlint",0,Cterm_def_ph::R_Rlint_,P,false,false){
}

